// Copyright (C) 2002-2011 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __C_D3D9_CONTEXT_H_INCLUDED__
#define __C_D3D9_CONTEXT_H_INCLUDED__


#include "IrrCompileConfig.h"


#ifdef _IRR_COMPILE_WITH_DIRECT3D_9_
#include "IVideoContext.h"

#include <windows.h>
#include <d3d9.h>


class IDirect3D9;
class IDirect3DDevice9;


namespace irr
{
namespace video
{

class CD3D9Driver;

class CD3D9Context : public IVideoContext
{
public:

    CD3D9Context(CD3D9Driver* driver, IDirect3DDevice9* device, const SVideoContextConfig& config, const bool& external );

    ~CD3D9Context();


    virtual core::dimension2du getSize() const
    {
        return getConfig().ContextSize;
    };

    virtual bool setSize( const core::dimension2du& dims )
    {
        return false;
    }

    bool setTarget(void * data);


    virtual bool isCompatibleWithRenderWindow(IRenderWindow* ) const;

    bool beginScene(DWORD flags, SColor color, core::rect<s32>* SceneSourceRect = 0);
    HRESULT endScene( DWORD flags );

    CD3D9Driver * getVideoDriver() const;
    IDirect3DDevice9* getDevice() const;

    void releaseContext();

	IDirect3DPixelShader9*  createPixelShader(const c8* pxsh);
	IDirect3DVertexShader9* createVertexShader(const char* vtxsh);
//	PixelShader;
//protected:
    //! Pointer to the IDirect3D9 interface
//    LPDIRECT3D9



//    IDirect3D9* D3D9;


    IDirect3DDevice9* pID3DDevice;  // TODO should remain in driver ?




    private:
        HWND WindowHandle;
        CD3D9Driver* VideoDriver;
        core::rect<s32>* SceneSourceRect;
//    D3DPRESENT_PARAMETERS present;
};

}
}

#endif // _IRR_COMPILE_WITH_WINDOWS_DEVICE_

#endif
